#include <stdio.h>
#include <stdlib.h>

#define DEBUG

typedef struct {
	char a, b;
} node;

long NA;
node A[100001];

long ca[26], cb[26];
int getto[26][26];
int visited[26];
int countfrom[26];
int countto[26];

int findwhat;
int found;
int canreach[26];

int cangetto[26];
int canleavefrom[26];

int visit(int p)
{
	int i;
	canreach[p] = 1;
	found++;
	if (found == findwhat)
		return 1;
	for (i=0; i<26; i++)
	{
		if (!canreach[i] && ca[i] && getto[p][i])
			if (visit(i))
				return 1;
	}
	return 0;
}

int visit_rev(int p)
{
	int i;
	canreach[p] = 1;
	found++;
	if (found == findwhat)
		return 1;
	for (i=0; i<26; i++)
	{
		if (!canreach[i] && ca[i] && getto[i][p])
			if (visit_rev(i))
				return 1;
	}
	return 0;
}

int main()
{
	long T, N, i, j, k;
	int l;
	char lbuf[1024];
	char buf[1024];
	int possible;
	int startplate, endplate;
	int start, reverse;

	fgets(lbuf, 1024, stdin);
	T = strtol(lbuf, NULL, 10);
	while (T--)
	{
		NA = 0;
		for (i=0; i<26; i++)
		{
			ca[i] = 0;
			cb[i] = 0;
			visited[i] = 0;
			cangetto[i] = 0;
			canleavefrom[i] = 0;
			countto[i] = 0;
			countfrom[i] = 0;
			for (j=0; j<26; j++)
			{
				getto[i][j] = 0;
			}
		}
		findwhat = 0;
		fgets(lbuf, 1024, stdin);
		N = strtol(lbuf, NULL, 10);
		for (i=0; i<N; i++)
		{
			fgets(buf, 1024, stdin);
			l = strlen(buf);
			if (buf[l-1] == '\n')
				l--;
			A[NA].a = buf[0]-'a';
			A[NA].b = buf[l-1]-'a';
			getto[A[NA].a][A[NA].b] = 1;
			canleavefrom[A[NA].a] = 1;
			countfrom[A[NA].a]++;
			cangetto[A[NA].b] = 1;
			countto[A[NA].b]++;
			NA++;
			if (ca[buf[0]-'a'] == 0)
				findwhat++;
			ca[buf[0]-'a']++;
			cb[buf[l-1]-'a']++;
		}
#ifdef DEBUG_OLD
		for (i=0; i<26; i++)
		{
			if (ca[i] || cb[i])
				printf("%c: %4ld, %4ld\n", (char) i+'a', ca[i], cb[i]);
		}
#endif
		possible = 1;
		startplate = -1;
		endplate = -1;

		for (i=0; i<26; i++)
		{
			if (cangetto[i] && !canleavefrom[i])
			{
				if (endplate != -1)
				{
					possible = 0;
					break;
				}
				endplate = i;
				if (countto[endplate] > 1)
				{
					possible = 0;
					break;
				}
			}
			if (canleavefrom[i] && !cangetto[i])
			{
				if (startplate != -1)
				{
					possible = 0;
					break;
				}
				startplate = i;
				if (countfrom[startplate] > 1)
				{
					possible = 0;
					break;
				}
			}
		}
		if (possible)
		{
			/* visit from start to end */
			start = -1;
			reverse = 0;
			if (startplate != -1)
			{
				start = startplate;
				reverse = 0;
			} else
				if (endplate != -1)
				{
					start = endplate;
					reverse = 1;
				}
#ifdef DEBUG
			printf("start at: %c\n", start+'a');
			printf("reverse: %d\n", reverse);
			printf("findwhat: %d\n", findwhat);
#endif
			if (!reverse)
			{
				for (j=0; j<26; j++)
					canreach[j] = 0;
				found = 0;
				if (start != -1 && !visit(start))
					possible = 0;
				if (start == -1)
				{
					possible = 0;
					for (j=0; j<26; j++)
					{
						if (cangetto[j] > 0)
						{
							for (k=0; k<26; k++)
								canreach[k] = 0;
							found = 0;
							if (visit(j))
							{
								possible = 1;
								break;
							}
						}
					}
				}
			} else
			{
				possible = 0;
				for (j=0; j<26; j++)
				{
					for (k=0; k<26; k++)
						canreach[k] = 0;
					found = 0;
					if (getto[j][start] && visit_rev(j))
					{
						possible = 1;
						break;
					}
				}
			}
		}
#ifdef DEBUG
		for (i=0; i<26; i++)
		{
			if (countfrom[i]  || countto[i])
			{
				printf("%c: %4d, %4d\n", (char) i+'a', countfrom[i], countto[i]);
			}
		}
#endif
		if (possible)
		{
#ifdef DEBUG
			if (startplate != -1)
				printf("start plate: %c\n", (char) startplate+'a');
			if (endplate != -1)
				printf("end plate: %c\n", (char) endplate+'a');
#endif
			printf("Ordering is possible.\n");
		} else
			printf("The door cannot be opened.\n");
	}
    return 0;
}
